import Acquisition, Record
from ZODB.POSException import ConflictError
# Switch for new behavior, raise exception instead of returning None.
# Use 'catalog-getObject-raises off' in zope.conf to restore old behavior.
GETOBJECT_RAISES = True

from Products.CMFPlone.utils import safe_callable
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.permissions import AccessContentsInformation, \
                        ManagePortal, ManageUsers, ModifyPortalContent, View
from patch_utils import wrap_method, call
from config import log
from Acquisition import aq_base,aq_inner,aq_parent
from Products.ZCatalog.ZCatalog import ZCatalog
from Products.CMFPlone.CatalogTool import ExtensibleIndexableObjectWrapper


from Products.ZCatalog.CatalogBrains import AbstractCatalogBrain


def getPath(self):
    """Get the physical path for this record"""
    #Use the path-index if its there
    pi = None
    try:
        #if the catalog is messed up, this crashes.
        pi = self.aq_parent.getIndexDataForRID(self.data_record_id_)
    except:
        pass
    if pi and pi.has_key('path'):
        return pi['path']
    #fallback for catalogs without pathindex
    return call(self, 'getPath')   
    #return self.aq_parent.getpath(self.data_record_id_)



#################################################
from BTrees.IIBTree import IISet, intersection, union, multiunion
from BTrees.OOBTree import OOBTree
from BTrees.OIBTree import OIBTree
from zLOG import LOG, ERROR
from Products.PluginIndexes.common.util import parseIndexRequest
from Products.PluginIndexes.common import safe_callable
from Products.ExtendedPathIndex.ExtendedPathIndex import ExtendedPathIndex

def search(self, path, default_level=0, depth=-1, navtree=0,
                                                          navtree_start=0):
     """
     path is either a string representing a
     relative URL or a part of a relative URL or
     a tuple (path,level).

     level >= 0  starts searching at the given level
     level <  0  not implemented yet
     """

     if isinstance(path, basestring):
         startlevel = default_level
     else:
         startlevel = int(path[1])
         path = path[0]

     absolute_path = isinstance(path, basestring) and path.startswith('/')

     comps = filter(None, path.split('/'))

     orig_comps = [''] + comps[:]
     # Optimization - avoid using the root set
     # as it is common for all objects anyway and add overhead
     # There is an assumption about catalog/index having
     # the same container as content
     if default_level == 0:
         indexpath = list(filter(None, self.getPhysicalPath()))
         while min(len(indexpath), len(comps)):
             if indexpath[0] == comps[0]:
                 del indexpath[0]
                 del comps[0]
                 startlevel += 1
             else:
                 break

     if len(comps) == 0:
         if depth == -1 and not navtree:
             return IISet(self._unindex.keys())

     # Make sure that we get depth = 1 if in navtree mode
     # unless specified otherwise

     orig_depth = depth
     if depth == -1:
         depth = 0 or navtree

     # Optimized navtree starting with absolute path
     if absolute_path and navtree and depth == 1 and default_level==0:
         set_list = []
         # Insert root element
         if navtree_start >= len(orig_comps):
             navtree_start = 0
         # create a set of parent paths to search
         for i in range(len(orig_comps), navtree_start, -1):
             parent_path = '/'.join(orig_comps[:i])
             parent_path = parent_path and parent_path or '/'
             try:
                 set_list.append(self._index_parents[parent_path])
             except KeyError:
                 pass
         return multiunion(set_list)
     # Optimized breadcrumbs
     elif absolute_path and navtree and depth == 0 and default_level==0:
         item_list = []
         tmp_set = IISet()
         # Insert root element
         if navtree_start >= len(orig_comps):
             navtree_start = 0
         # create a set of parent paths to search
         for i in range(len(orig_comps), navtree_start, -1):
             parent_path = '/'.join(orig_comps[:i])
             parent_path = parent_path and parent_path or '/'
             try:
                 orig_path = '/'.join(orig_comps[:i+1])
                 tmp_set = self._index_parents[parent_path]
                 item_list.append(IISet([id for id in tmp_set if self.getEntryForObject(id) == orig_path]))
             except KeyError:
                 pass
         return multiunion(item_list)
     # Specific object search
     elif absolute_path and orig_depth == 0 and default_level == 0:
         try:
             return IISet([self._index_items[path]])
         except KeyError:
             return IISet()
     # Single depth search
     elif absolute_path and orig_depth == 1 and default_level == 0:
         # only get objects contained in requested folder
         try:
             return self._index_parents[path]
         except KeyError:
             return IISet()
     # Sitemaps, relative paths, and depth queries
     elif startlevel >= 0:

         pathset = None # Same as pathindex
         navset  = None # For collecting siblings along the way
         depthset = None # For limiting depth

         if navtree and depth and \
                self._index.has_key(None) and \
                self._index[None].has_key(startlevel):
             navset = self._index[None][startlevel]

         for level in range(startlevel, startlevel+len(comps) + depth):
             if level-startlevel < len(comps):
                 comp = comps[level-startlevel]
                 if not self._index.has_key(comp) or not self._index[comp].has_key(level): 
                     # Navtree is inverse, keep going even for
                     # nonexisting paths
                     if navtree:
                         pathset = IISet()
                     else:
                         return IISet()
                 else:
                     pathset = intersection(pathset,
                                                  self._index[comp][level])
                 if navtree and depth and \
                        self._index.has_key(None) and \
                        self._index[None].has_key(level+depth):
                     navset  = union(navset, intersection(pathset,
                                           self._index[None][level+depth]))
             if level-startlevel >= len(comps) or navtree:
                 if self._index.has_key(None) and self._index[None].has_key(level):
                     depthset = union(depthset, intersection(pathset,
                                                 self._index[None][level]))

         if navtree:
             return union(depthset, navset) or IISet()
         elif depth:
             return depthset or IISet()
         else:
             return pathset or IISet()

     else:
         results = IISet()
         for level in range(0,self._depth + 1):
             ids = None
             error = 0
             for cn in range(0,len(comps)):
                 comp = comps[cn]
                 try:
                     ids = intersection(ids,self._index[comp][level+cn])
                 except KeyError:
                     error = 1
             if error==0:
                 results = union(results,ids)
         return results

            
#this is the uggliest hack i eer did... sorry. Please refactor it...
#this does not work if you are not in debug mode...
def WeAreOnTheStack():
    import inspect
    st = inspect.stack()
    st.pop(0)
    me = frame = st.pop(0)
    for frame in st:
        if (frame[1],frame[3]) == (me[1],me[3]):
            return True
    return False

def _catalog_object(self, obj, uid=None, idxs=None, update_metadata=1, pghandler=None, ):
    if not WeAreOnTheStack() and self.id == 'portal_catalog':
        try:
            obj.reindexObject(idxs)
            return
        except:
            pass
    return call(self, 'catalog_object', obj, uid, idxs, update_metadata, pghandler)   

def _uncatalog_object(self, uid):
    """Wrapper around catalog """
    if not WeAreOnTheStack() and self.id == 'portal_catalog':
        try:
            obj = self.resolve_path(uid)
            obj.unindexObject()
            return
        except:
            pass
    return call(self, 'uncatalog_object', uid)

 
def uncatalog_object(self, uid, calleris_unindexObject=None):
        """Wrapper around catalog """
        try:
            obj = self.resolve_path(uid)
            mt = obj.meta_type
        except:
            mt = None
        
        if not calleris_unindexObject and mt=='I18NFolder':
            obj.unindexObject()
            return
        self._catalog.uncatalogObject(uid)


def catalog_object(self, object, uid, idxs=[],
                   update_metadata=1, pghandler=None,calleris_reindexObject=None):
    # Wraps the object with workflow and accessibility
    # information just before cataloging.
    wf = getattr(self, 'portal_workflow', None)
    # A comment for all the frustrated developers which aren't able to pin
    # point the code which adds the review_state to the catalog. :)
    # The review_state var and some other workflow vars are added to the
    # indexable object wrapper throught the code in the following lines
    try:
        mt = object.meta_type
    except:
        mt = None
    
    if not calleris_reindexObject and mt =='I18NFolder':
        object.reindexObject(idxs,update_metadata)
        return
    
    if wf is not None:
        vars = wf.getCatalogVariablesFor(object)
    else:
        vars = {}
    portal = aq_parent(aq_inner(self))
    w = ExtensibleIndexableObjectWrapper(vars, object, portal=portal)
    try:
        # pghandler argument got added in Zope 2.8
        ZCatalog.catalog_object(self, w, uid, idxs,
                                update_metadata, pghandler=pghandler)
    except TypeError:
        try:
            # update_metadata argument got added somewhere into
            # the Zope 2.6 line (?)
            ZCatalog.catalog_object(self, w, uid, idxs, update_metadata)
        except TypeError:
            ZCatalog.catalog_object(self, w, uid, idxs)
            





def run():
    log('Applying patches...')
    #from Products.ZCatalog.ZCatalog import ZCatalog
    #wrap_method(ZCatalog, 'catalog_object', catalog_object)
    #wrap_method(ZCatalog, 'uncatalog_object', uncatalog_object)
    from Products.CMFPlone.CatalogTool import CatalogTool
    wrap_method(CatalogTool, 'catalog_object', catalog_object)
    wrap_method(CatalogTool, 'uncatalog_object', uncatalog_object)
    
    from Products.ExtendedPathIndex.ExtendedPathIndex import ExtendedPathIndex
    wrap_method(ExtendedPathIndex, 'search', search)
    from Products.ZCatalog.CatalogBrains import AbstractCatalogBrain
    wrap_method(AbstractCatalogBrain, 'getPath', getPath)
