#
# Neutral Tests
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase

from Products.I18NFolder.tests import I18NFolderTestCase
from Products.I18NFolder.tests.utils import makeContent
from Products.I18NFolder.tests.utils import makeTranslation

class TestEFNNeutral(I18NFolderTestCase.I18NFolderTestCase):

    def afterSetUp(self):
        self.setLanguage('en')
        self.addLanguage('de')
        self.english = makeContent(self.folder, 'I18NFolder', 'doc')

    def testSetExcludeFromNavA(self):
        get_transaction().commit(1)
        self.english.setExcludeFromNav(True)
        #self.german.processForm(values={'title':'Not Second'})
        self.assertEqual(self.english.getExcludeFromNav(), True)

    def testSetExcludeFromNavB(self):
        get_transaction().commit(1)
        self.english.processForm(values={'excludeFromNav':True})
        #self.german.processForm(values={'title':'Not Second'})
        #self.assertEqual(self.english.getExcludeFromNav(), True)


class TestEFNTrans(I18NFolderTestCase.I18NFolderTestCase):

    def afterSetUp(self):
        self.addLanguage('de')
        self.addLanguage('fr')
        self.setLanguage('en')
        self.english = makeContent(self.folder, 'I18NFolder', 'doc')
        self.english.setLanguage('en')
        self.german = makeTranslation(self.english, 'de')

    def testSetExcludeFromNavTrans(self):
        get_transaction().commit(1)
        #self.english.processForm(values={'excludeFromNav':True})
        self.english.setExcludeFromNav(True)
        #self.german.processForm(values={'title':'Not Second'})
        self.assertEqual(self.english.getExcludeFromNav(), True)



def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestEFNNeutral))
    #suite.addTest(makeSuite(TestEFNTrans))
    
    return suite

if __name__ == '__main__':
    framework()
