#
# Setup Tests
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase

from Products.I18NFolder.tests import I18NFolderTestCase

from Products.CMFPlone.CatalogTool import CatalogTool
from Products.I18NFolder import config

import Globals
from Acquisition import aq_base


class TestPatchesSetup(I18NFolderTestCase.I18NFolderTestCase):
    pass
    #def testRequestPatch(self):
        #if config.GLOBAL_REQUEST_PATCH:
            #self.failUnless(hasattr(Globals, 'get_request'))
        #else:
            #self.failIf(hasattr(Globals, 'get_request'))
    # need a test here!
    #def testCatalogPatch(self):
        #if config.I18NAWARE_CATALOG:
            #self.failUnless(hasattr(CatalogTool, '__old_searchResults'))
        #else:
            #self.failIf(hasattr(CatalogTool, '__old_searchResults'))


class TestInstallSetup(I18NFolderTestCase.I18NFolderTestCase):

    def testTools(self):
        # Check all tools are installed
        portal = aq_base(self.portal)
        self.failUnless(hasattr(portal, 'archetype_tool'))
        self.failUnless(hasattr(portal, 'portal_languages'))

    def testPortalTypes(self):
        # Check all content types are installed
        types = aq_base(self.portal.portal_types)
        #self.failUnless(hasattr(types, 'Lingua Item'))
        #self.failUnless(hasattr(types, 'Lingua Folder'))
        # Dummies
        #self.failUnless(hasattr(types, 'SimpleType'))
        #self.failUnless(hasattr(types, 'DerivedType'))
        #self.failUnless(hasattr(types, 'SimpleFolder'))
        #self.failUnless(hasattr(types, 'OrderedFolder'))
        #self.failUnless(hasattr(types, 'BTreeFolder'))
        self.failUnless(hasattr(types, 'I18NFolder'))

    def testExampleTypes(self):
        self.folder.invokeFactory('I18NFolder', id='foo')
        self.failUnless('foo' in self.folder.objectIds())
        

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestPatchesSetup))
    suite.addTest(makeSuite(TestInstallSetup))
    return suite

if __name__ == '__main__':
    framework()
